#directories
CSOU = SOURCE/SHARED
SSOU = SOURCE/SIMULAT
RSOU = SOURCE/READNET
EDT = EDIT
OBJ = ../$(GSPN2BINS)/2bin
INC = INCLUDE
TRS = TRANSL

#commands
COMP = gcc  -c -O3 -w -o
LINK = gcc  -O3 -w -o
LFLAGS = -lm -ll
#LFLAGS = -lm -lnsl -ll

#files groups
EXECUTABLES  =	WNSYMB
T_INCLUDES = ${INC}/const.ss \
	     ${INC}/struct.h \
	     ${INC}/var_ext.h \
	     ${INC}/decl.h \
	     ${INC}/fun_ext.h \
	     ${INC}/macros.h
T_OBJECTS = ${OBJ}/SSSYMBOLIC_net.o \
	    ${OBJ}/SSSYMBOLIC_def.o \
	    ${OBJ}/SSSYMBOLIC_grammar.o \
	    ${OBJ}/SSSYMBOLIC_service.o \
	    ${OBJ}/SSSYMBOLIC_token.o \
	    ${OBJ}/SSSYMBOLIC_dimensio.o \
	    ${OBJ}/SSSYMBOLIC_errors.o \
	    ${OBJ}/SSSYMBOLIC_common.o \
	    ${OBJ}/SSSYMBOLIC_report.o \
	    ${OBJ}/SSSYMBOLIC_enabling.o \
	    ${OBJ}/SSSYMBOLIC_fire.o\
	    ${OBJ}/SSSYMBOLIC_shared1.o\
	    ${OBJ}/SSSYMBOLIC_shared2.o\
	    ${OBJ}/SSSYMBOLIC_outdom.o\
	    ${OBJ}/SSSYMBOLIC_precheck.o \
	    ${OBJ}/SSSYMBOLIC_flush.o \
	    ${OBJ}/SSSYMBOLIC_degree.o \
	    ${OBJ}/SSSYMBOLIC_split.o \
	    ${OBJ}/SSSYMBOLIC_group.o \
	    ${OBJ}/SSSYMBOLIC_increm.o\
	    ${OBJ}/SSSYMBOLIC_engine.o \
	    ${OBJ}/SSSYMBOLIC_random.o \
	    ${OBJ}/SSSYMBOLIC_stat.o \
	    ${OBJ}/SSSYMBOLIC_distribu.o \
	    ${OBJ}/SSSYMBOLIC_eng_wn.o \
	    ${OBJ}/SSSYMBOLIC_presel.o\
	    ${OBJ}/SSSYMBOLIC_after.o\
	    ${OBJ}/SSSYMBOLIC_read_arc.o \
	    ${OBJ}/SSSYMBOLIC_read_t_c.o \
	    ${OBJ}/SSSYMBOLIC_read_t_s.o \
	    ${OBJ}/SSSYMBOLIC_wn_yac.o
T_SOURCES = ${CSOU}/service.c \
	    ${CSOU}/token.c \
	    ${CSOU}/dimensio.c \
	    ${CSOU}/errors.c \
	    ${CSOU}/common.c \
	    ${CSOU}/enabling.c	\
	    ${CSOU}/fire.c\
	    ${CSOU}/shared1.c\
	    ${CSOU}/shared2.c\
	    ${CSOU}/outdom.c\
	    ${CSOU}/report.c\
	    ${CSOU}/precheck.c \
	    ${CSOU}/flush.c \
	    ${CSOU}/degree.c \
	    ${CSOU}/split.c \
	    ${CSOU}/group.c \
	    ${SSOU}/eng_wn.c \
	    ${SSOU}/engine.c \
	    ${SSOU}/distribu.c \
	    ${SSOU}/increm.c\
	    ${SSOU}/presel.c\
	    ${SSOU}/random.c\
	    ${SSOU}/stat.c\
	    ${SSOU}/after.c\
	    ${RSOU}/read_arc.c \
	    ${RSOU}/read_t_c.c \
	    ${RSOU}/read_t_s.c \
	    ${RSOU}/wn_yac.c
T_LEX = ${TRS}/wn.lex \
	${TRS}/net.lex \
	${TRS}/def.lex
T_YACC = ${TRS}/wn.yac

#general rules
#${EXECUTABLES} : ${T_INCLUDES} ${T_LEX} ${T_YACC} {T_SOURCES}

${OBJ}/WNSYMB : ${T_INCLUDES} ${T_OBJECTS} ${T_LEX} ${T_YACC} ${CSOU}/main.c
	${LINK} ${OBJ}/WNSYMB ${CSOU}/main.c ${T_OBJECTS} ${LFLAGS}

${OBJ}/SSSYMBOLIC_outdom.o : ${CSOU}/outdom.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_outdom.o ${CSOU}/outdom.c

${OBJ}/SSSYMBOLIC_shared1.o : ${CSOU}/shared1.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_shared1.o ${CSOU}/shared1.c

${OBJ}/SSSYMBOLIC_shared2.o : ${CSOU}/shared2.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_shared2.o ${CSOU}/shared2.c

${OBJ}/SSSYMBOLIC_precheck.o : ${CSOU}/precheck.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_precheck.o ${CSOU}/precheck.c

${OBJ}/SSSYMBOLIC_fire.o : ${CSOU}/fire.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_fire.o ${CSOU}/fire.c

${OBJ}/SSSYMBOLIC_degree.o : ${CSOU}/degree.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_degree.o ${CSOU}/degree.c

${OBJ}/SSSYMBOLIC_report.o : ${CSOU}/report.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_report.o ${CSOU}/report.c
       
${OBJ}/SSSYMBOLIC_flush.o : ${CSOU}/flush.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_flush.o ${CSOU}/flush.c
       
${OBJ}/SSSYMBOLIC_common.o : ${CSOU}/common.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_common.o ${CSOU}/common.c
       
${OBJ}/SSSYMBOLIC_errors.o : ${CSOU}/errors.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_errors.o ${CSOU}/errors.c
       
${OBJ}/SSSYMBOLIC_dimensio.o : ${CSOU}/dimensio.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_dimensio.o ${CSOU}/dimensio.c
       
${OBJ}/SSSYMBOLIC_enabling.o : ${CSOU}/enabling.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/SSSYMBOLIC_enabling.o ${CSOU}/enabling.c
       
${OBJ}/SSSYMBOLIC_token.o : ${CSOU}/token.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_token.o ${CSOU}/token.c
       
${OBJ}/SSSYMBOLIC_service.o : ${CSOU}/service.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_service.o ${CSOU}/service.c
       
${OBJ}/SSSYMBOLIC_split.o : ${CSOU}/split.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_split.o ${CSOU}/split.c
       
${OBJ}/SSSYMBOLIC_group.o : ${CSOU}/group.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_group.o ${CSOU}/group.c
       
${OBJ}/SSSYMBOLIC_engine.o : ${SSOU}/engine.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_engine.o ${SSOU}/engine.c
       
${OBJ}/SSSYMBOLIC_eng_wn.o : ${SSOU}/eng_wn.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_eng_wn.o ${SSOU}/eng_wn.c
       
${OBJ}/SSSYMBOLIC_distribu.o : ${SSOU}/distribu.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_distribu.o ${SSOU}/distribu.c
       
${OBJ}/SSSYMBOLIC_stat.o : ${SSOU}/stat.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_stat.o ${SSOU}/stat.c
       
${OBJ}/SSSYMBOLIC_random.o : ${SSOU}/random.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_random.o ${SSOU}/random.c
       
${OBJ}/SSSYMBOLIC_increm.o : ${SSOU}/increm.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/SSSYMBOLIC_increm.o ${SSOU}/increm.c

${OBJ}/SSSYMBOLIC_presel.o : ${SSOU}/presel.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/SSSYMBOLIC_presel.o ${SSOU}/presel.c

${OBJ}/SSSYMBOLIC_after.o : ${SSOU}/after.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/SSSYMBOLIC_after.o ${SSOU}/after.c

${OBJ}/SSSYMBOLIC_wn_yac.o : ${RSOU}/wn_yac.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_wn_yac.o ${RSOU}/wn_yac.c
       
${OBJ}/SSSYMBOLIC_read_arc.o : ${RSOU}/read_arc.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_read_arc.o ${RSOU}/read_arc.c
       
${OBJ}/SSSYMBOLIC_read_t_s.o : ${RSOU}/read_t_s.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_read_t_s.o ${RSOU}/read_t_s.c
       
${OBJ}/SSSYMBOLIC_read_t_c.o : ${RSOU}/read_t_c.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_read_t_c.o ${RSOU}/read_t_c.c
       
${OBJ}/SSSYMBOLIC_grammar.o : SOURCE/grammar.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_grammar.o SOURCE/grammar.c

${OBJ}/SSSYMBOLIC_net.o : SOURCE/net.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_net.o SOURCE/net.c

${OBJ}/SSSYMBOLIC_def.o : SOURCE/def.c ${T_INCLUDES}
	${COMP} ${OBJ}/SSSYMBOLIC_def.o SOURCE/def.c

SOURCE/lex.c : ${TRS}/wn.lex
	lex ${TRS}/wn.lex
	mv lex.yy.c SOURCE/lex.c
	ed SOURCE/lex.c < ${EDT}/ed_lex

SOURCE/grammar.c : ${TRS}/wn.yac SOURCE/lex.c ${T_INCLUDES}
	yacc ${TRS}/wn.yac
	mv y.tab.c SOURCE/grammar.c
	ed SOURCE/grammar.c < ${EDT}/ed_gram

SOURCE/net.c : ${TRS}/net.lex ${T_INCLUDES}
	lex ${TRS}/net.lex
	mv lex.yy.c SOURCE/net.c
	ed SOURCE/net.c < ${EDT}/ed_net

SOURCE/def.c : ${TRS}/def.lex ${T_INCLUDES}
	lex ${TRS}/def.lex
	mv lex.yy.c SOURCE/def.c
	ed SOURCE/def.c < ${EDT}/ed_def
