#include <stdio.h>

void store_compact( nval, fp )
 unsigned long nval;
 FILE * fp;
 {/* Init store_compact */
  register unsigned char cc;

  if ( nval < 128 )
   {
    cc = (unsigned char)( 0x7F & nval);
    putc(cc, fp);
   }
  else if ( nval < 16384 )
   {
    cc = (unsigned char)(0x80 | ((0x3F00 & nval)>>8));
    putc(cc, fp);
    cc = (unsigned char)(0xFF & nval);
    putc(cc, fp);
   }
  else
   {
    cc = (unsigned char)(0xC0 | ((0x3F0000 & nval)>>16));
    putc(cc, fp);
    cc = (unsigned char)((0xFF00 & nval)>>8);
    putc(cc, fp);
    cc = (unsigned char)(0xFF & nval);
    putc(cc, fp);
   }
 }/* End store_compact */

void load_compact( pp, fp )
 unsigned long * pp;
 FILE * fp;
 {/* Init load_compact */
  register unsigned char cc = getc(fp);
  register unsigned long lc = cc;

  if ( 0x80 & lc )
   {
    register unsigned long uu = (lc & 0x3F)<<8;
    cc = getc(fp);
    uu += cc;
    if ( 0x40 & lc )
     {
      uu = uu<<8;
      cc = getc(fp);
      uu += cc;
     }
    *pp = uu;
   }
  else
   *pp = lc;
 }/* End load_compact */

void store_double( dval, fp )
 unsigned char * dval;
 FILE * fp;
 {/* Init store_double */
  register unsigned i = sizeof(double);

  for ( ; i-- ; dval++ )
   putc(*dval, fp);
 }/* End store_double */

void load_double( dval, fp )
 unsigned char * dval;
 FILE * fp;
 {/* Init load_double */
  register unsigned i = sizeof(double);

  for ( ; i-- ; dval++ )
   *dval = getc(fp);
 }/* End load_double */
