/*
 *  Paris, February 12, 1990
 *  program: gmt_stndrd.c
 *  purpose: Conversion of the TRG of a GSPN into a MC
 *           without net-dependent files compilation.
 *  programmer: Giovanni Chiola
 *  notes:
 *   1) No marking dependency is allowed for immediate transition weights.
 */

/*#define SOLARIS24*/

/*
#define DEBUG
*/

#ifdef DEBUG

#define DEBUGCALLS
/*
*/

#endif

#define PRINT_STATISTICS
/*
*/


#define EPS 0.00000001 /* The equivalence threshold for "double" */


#include <math.h>
#include "sconst.h"

#define MYMRKSLOT 100


#include "grg.h"

/* void (*terminate)(); */
terminate() { exit(1); }

/*group_num, trans_num;*/

#include <stdio.h>

FILE * nfp, * rgfp, * auxfp, *aefp, *trsfp;
FILE * matfp, * doufp, * marfp;


int load_trs, no_cod;

unsigned char * CMp;
unsigned short * DMp;

double eps, g_coef, l_coef;

double * M0, * d_p;


struct Cond_def {
  char op;
  char type;
  char top2;
  int p1;
  int op2;
};
 
 
union Val_type {
  double real;
  unsigned place;
};
 
 
struct Val_def {
  char op;
  char type;
  union Val_type val;
};

 
struct Clause_def {
  char type;
  int nocond;
  int noval;
  struct Val_def * vals;
  struct Cond_def * conds;
};


union MD_prob {
  double * prob;
  struct Clause_def * mdc;
};

struct Trans_weight {
  unsigned short noecs;
  unsigned short endep;
  double rate;
  union MD_prob md_p;
};

struct ECS_descr {
    unsigned num;
    unsigned * set;
};


/* TRANSITION ARRAY */ struct Trans_weight * t_list;
struct ECS_descr * aecs, *aecs_p;

unsigned lastan, toptan;

char *
ecalloc ( nitm, sz )
unsigned nitm, sz;
    {
    extern char *       calloc();
    char *              callptr;
 
    if ((callptr = calloc(nitm, sz)) == NULL) {
        fprintf(stderr,"ecalloc: couldn't fill request for %d, %d\n",
            nitm, sz );
/*        (*terminate)(); */
        terminate();
      }
    return(callptr);
}


struct d_tree_itm {
    double val;
    unsigned short l_s;
    unsigned short g_s;
    char balance;
};
struct d_tree_itm d_t_list[MAX_ITEMS];
char pathdir[L2_MAX_ITEMS];
unsigned top_d_tree = 0, root_d_tree = 0;
struct d_tree_itm * unbances;
struct d_tree_itm * unanfath;
struct d_tree_itm * father;
unsigned ancdepth;
    unsigned depth = 0;


rebalance( newn )
struct d_tree_itm * newn;
    {
    char * p_d_p = &(pathdir[ancdepth]);
    register int ancomp = *(p_d_p++);
    register unsigned n_d_p = ((ancomp>0)?(unbances->g_s):
					  (unbances->l_s));
    struct d_tree_itm * d_p = d_t_list + n_d_p;
    struct d_tree_itm * d_p_2 = d_p;
    register unsigned nn;
    register int aux;
#ifdef DEBUGCALLS
    fprintf(stderr,"        Start of rebalance newn=%d\n", (int)newn );
#endif

    while ( d_p_2 != newn ) {  /* ADJUST BRANCH BALANCING  */
	if ( *(p_d_p++) > 0 ) {
	    d_p_2->balance = 1;
	    nn = d_p_2->g_s;
	  }
	else {
	    d_p_2->balance = -1;
	    nn = d_p_2->l_s;
	  }
	d_p_2 = d_t_list + nn;
      }
    if ( ! (aux = unbances->balance) ) {  /* HIGHER TREE  */
	unbances->balance = ancomp;
#ifdef DEBUGCALLS
    fprintf(stderr,"        End of rebalance (higher)\n");
#endif
	return;
      }
    if ( aux != ancomp ) {  /*  BALANCED TREE  */
	unbances->balance = 0;
#ifdef DEBUGCALLS
    fprintf(stderr,"        End of rebalance (balanced)\n");
#endif
	return;
      }
    /*  UNBALANCED TREE  */
    aux = d_p->balance;
    if ( ancomp == aux ) {  /*  SINGLE ROTATION  */
	d_p_2 = d_p;
	if ( ancomp > 0 ) {
	    unbances->g_s = d_p->l_s;
	    nn = unbances - d_t_list;
	    d_p->l_s = nn;
	  }
	else {
	    unbances->l_s = d_p->g_s;
	    nn = unbances - d_t_list;
	    d_p->g_s = nn;
	  }
	unbances->balance = d_p->balance = 0;
      }
    else {  /*  DOUBLE ROTATION  */
	if ( ancomp > 0 ) {
	    nn = d_p->l_s;
	    d_p_2 = d_t_list + nn;
	    d_p->l_s = d_p_2->g_s;
	    d_p_2->g_s = n_d_p;
	    unbances->g_s = d_p_2->l_s;
	    nn = unbances - d_t_list;
	    d_p_2->l_s = nn;
	  }
	else {
	    nn = d_p->g_s;
	    d_p_2 = d_t_list + nn;
	    d_p->g_s = d_p_2->l_s;
	    d_p_2->l_s = n_d_p;
	    unbances->l_s = d_p_2->g_s;
	    nn = unbances - d_t_list;
	    d_p_2->g_s = nn;
	  }
	aux = d_p_2->balance;
	if ( aux == ancomp ) {
	    unbances->balance = -ancomp;
	    d_p_2->balance = d_p->balance = 0;
	  }
	else if ( aux ) {
	    d_p_2->balance = unbances->balance = 0;
	    d_p->balance = ancomp;
	  }
	else
	    unbances->balance = d_p->balance = 0;
      }
    /*  ROOT ADJUSTMENT  */
    nn = d_p_2 - d_t_list;
    if ( unanfath == NULL )
	root_d_tree = nn;
    else {
	if ( pathdir[ancdepth-1] > 0 )
	  unanfath->g_s = nn;
	else
	  unanfath->l_s = nn;
      }
#ifdef DEBUGCALLS
    fprintf(stderr,"        End of rebalance (normal)\n");
#endif
}


#ifdef PRINT_STATISTICS
unsigned max_nel = 0;
unsigned max_depth = 0;
unsigned long tot_depth = 0;
unsigned long num_call = 0;
#endif


unsigned short test_ins_d( dval )
double dval;
    {
    register unsigned nn = root_d_tree;
    struct d_tree_itm * d_p;
    register unsigned  udval_f, ldval_f;
    double udval, ldval;
    char * path = pathdir;

#ifdef DEBUGCALLS
    fprintf(stderr,"    Start of test_ins_d %f\n", dval );
#endif
    if ( nn ) {
	depth = 0;
#ifdef PRINT_STATISTICS
    ++num_call;
#endif
	father = unanfath = NULL;
	unbances = d_t_list + nn;
	ancdepth = 0;
	udval_f = TRUE;;
	ldval_f = TRUE;;
	for ( ; ; father = d_p, ++depth, ++path ) {
	    d_p = d_t_list + nn;
	    if ( d_p->val == dval ) {
#ifdef PRINT_STATISTICS
    tot_depth += depth;
    if ( depth > max_depth )
	max_depth = depth;
#endif
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of test_ins_d (old #%d\n", nn );
#endif
		return( nn );
	      }
	    if ( udval_f ) {
		udval = dval * g_coef;
		udval_f = FALSE;
	      }
	    if ( d_p->val > udval ) {
		*path = -1;
		if ( ! d_p->l_s ) {
		    d_p->l_s = nn = ++top_d_tree;
		    if ( nn >= MAX_ITEMS ) {
			fprintf(stderr,"Sorry, increase constant MAX_ITEMS\n");
			exit(15);
		      }
		    d_p = d_t_list + nn;
		    d_p->val = dval; d_p->l_s = 0; d_p->g_s = 0;
		    d_p->balance = 0;
		    rebalance( d_p );
#ifdef PRINT_STATISTICS
    tot_depth += depth;
    if ( depth > max_depth )
	max_depth = depth;
#endif
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of test_ins_d (new #%d\n", nn );
#endif
		    return( nn );
		  }
		nn = d_p->l_s;
		if ( d_p->balance ) {
		    unanfath = father; unbances = d_p; ancdepth = depth;
		  }
	      }
	    else {
		if ( ldval_f ) {
		    ldval = dval * l_coef;
		    ldval_f = FALSE;
		  }
		if ( d_p->val < ldval ) {
		    *path = 1;
		    if ( ! d_p->g_s ) {
			d_p->g_s = nn = ++top_d_tree;
			if ( nn >= MAX_ITEMS ) {
			    fprintf(stderr,"Sorry, increase constant MAX_ITEMS\n");
			    exit(15);
			  }
			d_p = d_t_list + nn;
			d_p->val = dval; d_p->l_s = 0; d_p->g_s = 0;
			d_p->balance = 0;
			rebalance( d_p );
#ifdef PRINT_STATISTICS
    tot_depth += depth;
    if ( depth > max_depth )
	max_depth = depth;
#endif
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of test_ins_d (new #%d\n", nn );
#endif
			return( nn );
		      }
		    nn = d_p->g_s;
		    if ( d_p->balance ) {
			unanfath = father; unbances = d_p; ancdepth = depth;
		      }
		  }
		else {
#ifdef PRINT_STATISTICS
    tot_depth += depth;
    if ( depth > max_depth )
	max_depth = depth;
#endif
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of test_ins_d (old #%d\n", nn );
#endif
		    return( nn );
		  }
	      }
	  }
      }
    d_p = d_t_list + 1;
    d_p->val = dval; d_p->l_s = 0; d_p->g_s = 0;
    d_p->balance = 0;
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of test_ins_d (first #1\n");
#endif
    return( root_d_tree = top_d_tree = 1 );
}


struct grph_itm_r {
    unsigned long  tm;
    double rt;
};



struct grph_itm_r row_l[MAX_ROW];
struct grph_itm_r * glp;

unsigned long frm, tmp;
unsigned nel;




insert_row( to, rate )
unsigned long to;
double rate;
    {
    struct grph_itm_r * glp2 = row_l;
    register unsigned ii = glp-row_l;

#ifdef DEBUGCALLS
    fprintf(stderr,"            Start of insert_row to=%d rate=%f\n",
      (int)to, (float)rate );
#endif
    for ( ; ii-- ; ++glp2 )
	if ( glp2->tm == to ) {
	    glp2->rt += rate;
#ifdef DEBUGCALLS
  fprintf(stderr,"            End of insert_row (added to already present)\n");
#endif
	    return;
	  }
    glp2->tm = to; glp2->rt = rate; ++nel; ++glp;
#ifdef DEBUGCALLS
  fprintf(stderr,"            End of insert_row (normal)\n");
#endif
    if ( nel >= MAX_ROW ) {
	fprintf(stderr,"Sorry, increase constant MAX_ROW\n");
	exit(17);
      }
}


unsigned long lnel;


struct grph_itm_l {
    unsigned long	fm;
    unsigned short	rt;
    struct grph_itm_l *	link;
};

struct grph_itm_l * free_p = NULL;

struct grph_itm_l ** tail;
unsigned short * weight;
unsigned long max_tan = 0;


struct grph_itm_l * new_grph()
    {
    struct grph_itm_l * g_p = free_p;

#ifdef DEBUGCALLS
    fprintf(stderr,"          Start of new_grph\n");
#endif
    if ( g_p == NULL ) {
      struct grph_itm_l * ret_p;
      register unsigned ii = MYMRKSLOT;
	g_p = (struct grph_itm_l*)ecalloc(ii,sizeof(struct grph_itm_l));
	ret_p = g_p;
	free_p = ++g_p;
	for ( --ii ; --ii ; ++g_p )
	    g_p->link = g_p+1;
	g_p->link = NULL;
#ifdef DEBUGCALLS
    fprintf(stderr,"          End of new_grph (alloc slot)\n");
#endif
	return ( ret_p );
      }
    free_p = g_p->link;
#ifdef DEBUGCALLS
    fprintf(stderr,"          End of new_grph (normal)\n");
#endif
    return ( g_p );
}

insert_graph( from, to, rate )
unsigned long from, to;
unsigned short rate;
    {
    struct grph_itm_l * g_p;

#ifdef DEBUGCALLS
    fprintf(stderr,"      Start of insert_graph from=%d to=%d rate=%d\n",
	(int)from, (int)to, (int)rate );
#endif
    if ( to > max_tan ) {  /* NEW COLUMN */
      register unsigned ii = toptan - max_tan;
      struct grph_itm_l ** g_pp = tail+max_tan;
      unsigned long incr = ((ii > MYMRKSLOT)? MYMRKSLOT : ii);
	incr = ii + to - max_tan;
	for ( ++ii, max_tan = to+incr ; --ii ; )
	    *++g_pp = NULL;
	g_pp = tail+to;  *g_pp = g_p = new_grph();
	g_p->link = g_p; g_p->fm = from; g_p->rt = rate;
#ifdef DEBUGCALLS
    fprintf(stderr,"      End of insert_graph (new column)\n");
#endif
	return;
      }
    if ( (g_p = tail[to]) == NULL ) {  /* INSERT FIRST ITEM */
	tail[to] = g_p = new_grph();
	g_p->link = g_p; g_p->fm = from; g_p->rt = rate;
#ifdef DEBUGCALLS
    fprintf(stderr,"      End of insert_graph (first item)\n");
#endif
	return;
      }
    if ( g_p->fm < from ) {  /* TAIL INSERTION */
      struct grph_itm_l * g_p2 = new_grph();
	tail[to] = g_p2;
	g_p2->link = g_p->link; g_p2->fm = from; g_p2->rt = rate;
	g_p->link = g_p2;
#ifdef DEBUGCALLS
    fprintf(stderr,"      End of insert_graph (tail insertion)\n");
#endif
	return;
      }
    { struct grph_itm_l * g_p2 = g_p->link;
	while ( g_p2->fm < from ) {
	    g_p = g_p2;  g_p2 = g_p2->link;
	  }
        g_p = g_p->link = new_grph();
	g_p->link = g_p2; g_p->fm = from; g_p->rt = rate;
    }
#ifdef DEBUGCALLS
    fprintf(stderr,"      End of insert_graph (normal)\n");
#endif
}



unsigned long tmp;


unsigned short * w_p;
struct grph_itm_l ** t_p;

store_transpose()
    {
    unsigned long tmp = *w_p;
    unsigned long nel = 0;
    struct grph_itm_l * g_p = *t_p;

#ifdef DEBUGCALLS
    fprintf(stderr,"    Start of store_transpose %d\n", w_p - weight);
#endif
    if ( g_p == NULL ) {
#ifdef DEBUG
    fprintf(stderr,"      not reachable\n");
#endif
      }
    else {
	for ( ++nel, g_p = g_p->link ; g_p != *t_p ;
	      ++nel, g_p = g_p->link );
#ifdef DEBUG
    fprintf(stderr,"      reachable from %d\n", nel);
#endif
      }
    store_compact(nel,matfp);
    store_compact(tmp,matfp);
    if ( ! nel ) {
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of store_transpose\n");
#endif
	return;
      }
    for ( g_p = g_p->link ; nel-- ; g_p = g_p->link ) {
	store_compact( g_p->fm, matfp );
	tmp = g_p->rt;  store_compact(tmp,matfp);
#ifdef DEBUG
    fprintf(stderr,"          from %d rate %d\n", g_p->fm, tmp);
#endif
      }
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of store_transpose\n");
#endif
}



init ()
    {
    int nm, Naecs, ii, ecs, nt, jj, pri;
    float rw;
    struct Trans_weight * trans_p;
    unsigned * ttt;

#ifdef DEBUGCALLS
    fprintf(stderr,"  Start of init\n");
#endif

    fscanf(auxfp,"toptan= %d\n", &toptan );

    tail = (struct grph_itm_l **)ecalloc(toptan+1,sizeof(struct grph_itm_l*));
    weight = (unsigned short*)ecalloc(toptan+1,sizeof(unsigned short));
    M0 = (double*)ecalloc(toptan+1,sizeof(double));
    for ( d_p = M0, ii = toptan ; ii-- ; *(++d_p) = 0.0 );
#ifdef DEBUGCALLS
    fprintf(stderr,"  End of init\n");
#endif
}

extern load_compact( /* lp, fp */ );
/*
  unsigned long * lp;
  FILE * fp;
*/


load_initialmark()
    {
    int nm;
    double pp;

#ifdef DEBUGCALLS
    fprintf(stderr,"    Start of load_initialmark\n" );
#endif
    fscanf( rgfp,"%d\n", &nm );
    if ( nm ) {
	M0[nm] = 1.0;
#ifdef DEBUG
    fprintf(stderr,"      M1 with prob. 1.0\n" );
#endif
      }
    else {
        for ( fscanf( rgfp,"%d", &nm ) ; nm ;
	      fscanf( rgfp,"%d", &nm )) {
	    fscanf( rgfp,"%lg\n", &pp );
#ifdef DEBUG
    fprintf(stderr,"      M%d with prob. %f\n", nm, pp );
#endif
	    M0[nm] = pp;
          }
	while ( getc(rgfp) != '\n' );
      }
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of load_initialmark\n" );
#endif
}


load_trg()
    {
    int no_trans, nm;
    double rr, sum;
    int next_print;
    int prevtan;

#ifdef DEBUGCALLS
    fprintf(stderr,"    Start of load_trg\n" );
#endif
    for ( prevtan = 0, fscanf(rgfp,"%d", &lastan ), next_print = 0 ; ;
	  fscanf(rgfp,"%d", &lastan ) ) {
	if ( lastan > prevtan ) {
	    if ( prevtan > 0 ) {
		if ( nel ) {
		    sum = 1.0/sum;
		    frm = test_ins_d( sum );
		    weight[prevtan] = frm;
		    for ( glp = row_l, no_trans = nel ; no_trans-- ; ++glp ) {
			glp->rt *= sum;
			frm = test_ins_d( glp->rt );
			insert_graph( prevtan, glp->tm, frm );
		      }
		  }
		else {
		    frm = test_ins_d( 0.0 );
		    weight[prevtan] = frm;
		  }
	      }
	    if ( lastan > toptan )
		break;
	    prevtan = lastan;
	    sum = 0.0;
	    nel = 0; glp = row_l;
	  }
	fscanf(rgfp,"%d", &nm );
	if ( nm ) {
	    fscanf(rgfp,"%lg\n", &rr );
	    if ( nm != lastan ) {
		sum += rr;
		insert_row( nm, rr );  /* INCREMENTS "nel" and "glp" */
	      }
	  }
	else while ( getc(rgfp) != '\n' );
#ifdef PRINT_STATISTICS
    if ( nel > max_nel )
	max_nel = nel;
#endif
	if ( lastan >= next_print ) {
	    next_print += 100;
	    /*fprintf(stderr," %6d\r", lastan);*/
	  }
      }
    fprintf(stderr," %6d rows computed\n\n", toptan);
#ifdef DEBUGCALLS
    fprintf(stderr,"    End of load_trg\n" );
#endif
}


static char  * can_t_open = "Can't open file %s for %c\n";
char  filename[100];


#include <sys/types.h>
#include <sys/stat.h>


#ifdef PRINT_STATISTICS
#ifdef SOLARIS24
#       include <sys/times.h>
#       include <limits.h>
#else
#	include <sys/time.h>
#	include <sys/resource.h>
#	define RUSAGE_SELF 0
#endif
#endif


main(argc,argv,envp)
int argc;
char ** argv;
char ** envp;
    {
    extern FILE *fopen();
#ifdef PRINT_STATISTICS
#ifdef SOLARIS24
    struct tms buffer;
#else
    struct rusage ru;
#endif
    float mean_depth;
#endif
    double dd;

#ifdef DEBUG
    fprintf(stderr,"Start of swn_stndrd\n");
#endif
    if ( argc < 2 ) {
	fprintf(stderr,"ERROR: no net name !\n");
	exit(1);
      }
    eps = EPS;
    if ( argc > 2 ) {
      char ** a_p = &(argv[2]);
      char * s_p;
      unsigned ii = argc-2;
	while ( ii-- ) {
	    s_p = *(a_p++);
	    if ( *s_p != '-' || *(s_p+1) != 'e' ) {
		fprintf(stderr,"ERROR: unknown parameter '%s'\n", s_p);
		exit(33);
	      }
	    sscanf((s_p+2),"%f",&eps);
	  }
      }
    g_coef = 1.0+eps;
    l_coef = 1.0-eps;
    sprintf(filename,"%s.rgr_aux",argv[1]);
    if ( (auxfp = fopen( filename, "r")) == NULL ) {
	fprintf(stderr,can_t_open,filename,'r');
	exit(1);
      }
    init();
    (void)fclose(auxfp);
    sprintf(filename,"%s.wngr",argv[1]);
    if ( (rgfp = fopen( filename, "r")) == NULL ) {
	fprintf(stderr,can_t_open,filename,'r');
	exit(1);
      }
    load_initialmark();
    sprintf(filename,"%s.epd",argv[1]);
    if ( (marfp = fopen( filename, "w")) == NULL ) {
	fprintf(stderr,can_t_open,filename,'w');
	exit(1);
      }
    M0[0] = 0.0; store_double( M0, marfp );
    store_double( M0, marfp );
    { unsigned ii;
	for ( d_p = M0, ii = toptan ; ii-- ; ) {
	    store_double( ++d_p, marfp );
	    store_double( d_p, marfp );
	  }
    }
    free(M0);
    (void) fclose(marfp);

    load_trg();
    (void) fclose(rgfp);

    sprintf(filename,"%s.emc",argv[1]);
    if ( (matfp = fopen( filename, "w")) == NULL ) {
	fprintf(stderr,can_t_open,filename,'w');
	exit(1);
      }
    store_compact(toptan,matfp);
    { unsigned ii;
	for ( ii = toptan, w_p = &(weight[1]), t_p = &(tail[1]) ;
	      ii-- ; ++w_p, ++t_p ) {
	    store_transpose();
	  }   
    }   
    nel = 0;  store_compact(nel,matfp);
    store_compact(nel,matfp);
    (void) fclose(matfp);

    sprintf(filename,"%s.doubles", argv[1] );
    if ( (doufp = fopen( filename, "w")) == NULL ) {
	fprintf(stderr,can_t_open,filename,'w');
	exit(1);
      }
    frm = top_d_tree;
    store_compact( frm, doufp );
    { unsigned ii;
	for ( ii = 0 ; ii++ < top_d_tree ; )
	    store_double( &(d_t_list[ii].val), doufp );
    }
    (void) fclose(doufp);

end_main:
#ifdef PRINT_STATISTICS
#ifdef SOLARIS24
    (void) times( &buffer );
#else
    getrusage( RUSAGE_SELF, &ru );
#endif
    fprintf(stderr,"\nnumber of doubles : %d\n", frm);
    fprintf(stderr,"maximum row length : %d\n", max_nel);
    fprintf(stderr,"maximum tree depth : %d\n", max_depth);
    mean_depth = tot_depth;
    mean_depth /= num_call;
    fprintf(stderr,"average tree depth : %f\n", mean_depth);
#ifdef SOLARIS24
    mean_depth = 1.0/CLK_TCK;
    fprintf(stderr,"\nCPU time (s.) : user %g, system %g\n\n",
	    mean_depth*buffer.tms_utime, mean_depth*buffer.tms_stime );
#else
    fprintf(stderr,"\nCPU time (s.) : user %d, system %d\n",
	  ru.ru_utime.tv_sec, ru.ru_stime.tv_sec );
    fprintf(stderr,"Max memory size : %d Kbyte\n",
	  ru.ru_maxrss * 2 );
    fprintf(stderr,"Page faults : reclaims %d, faults %d\n",
	  ru.ru_minflt, ru.ru_majflt );
    fprintf(stderr,"Context Switches : voluntary %d, forced %d\n",
	  ru.ru_nvcsw, ru.ru_nivcsw );
    fprintf(stderr,"Swap : %d\n\n",
	  ru.ru_nswap );
#endif
#endif
#ifdef DEBUG
    fprintf(stderr,"End of swn_stndrd\n");
#endif
}

