#include <stdio.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/var_ext.h"
#include "../../INCLUDE/macros.h"

#ifdef REACHABILITY

extern void initialize_en_list();
extern void update_en_list();
extern void fire_trans();
extern void push_result();
extern void push_rate();
extern void write_ctrs();
extern void write_grg();
extern void write_on_srg();
extern void write_final_results();
extern void update_rg_files();
extern void out_cur_marking();
extern void string_to_marking();

extern int marking_to_string();

extern MRate_p rate_pop();
extern Event_p get_new_event();

static Tree_p fire_ptr = NULL;	 /* Puntatore alla marcatura di sparo	 */
static Tree_p top = NULL;	 /* Puntatori al top e al bottom dello	 */
static Tree_p bottom = NULL;	 /* Stack di marcature da espandere	 */
static Tree_p root = NULL;	 /* Albero delle marcature raggiunte	 */

Tree_p reached_marking = NULL;
Tree_p initial_marking = NULL;
Tree_p current_marking = NULL;

Result_p enabled_head = NULL;	/* Puntatori alla lista delle tr. abil. */

int tro;			/* 1 marc. gia' raggiunta, 0 altrimenti */
int marcatura = 0;	/* contatore per le marcature		*/
int h = 0;			/* per bilanciamento nella insert_tree	*/
int tang = 0;		/* contatori tipi di marc. raggiunte	*/
int evan = 0;
int dead = 0;
int home = 0;
int cont_tang;

#ifdef SYMBOLIC
extern void create_canonical_data_structure();
extern void get_canonical_marking();

double mark_ordinarie;	    /* num. marc. ord. per marc. simbolica  */
double ord_tang = 0.0;
double ord_evan = 0.0;
double ord_dead = 0.0;

extern Canonic_p sfl_h;
#endif

int cur_priority;

int *code_place = NULL;
int *min_place = NULL;
int *max_place = NULL;
int *init_place = NULL;

int max_priority = 0;
int old_time,new_time;

static MRate_p path_head_ptr = NULL;

/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void arrcpy(s,t,lim)
 int *s,*t;
 {/* Init arrcpy */
  int i;

  for( i = lim ; i ; i-- )
   s[i-1] = t[i-1];
 }/* End arrcpy */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void append(head,add_head)
 MRate_p *head;
 MRate_p add_head;
 {/* Init append */
  MRate_p list = NULL;

  if(*head == NULL) 
   *head = add_head;
  else 
   {
    MRate_p nxt;
    MRate_p prv;

    prv = NULL;
    for( list = *head; list != NULL; list = nxt)
     {
      nxt = list->next; 
      prv = list;
     }
    prv->next = add_head;
   }
 }/* End append */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void fusion(head,add_head)
 MRate_p *head;
 MRate_p add_head;
 {/* Init fusion */
  MRate_p pun;
  MRate_p ptr;
  MRate_p nxt;

  pun = add_head;
  while (pun != NULL)
   {/* Per ogni elemento */
    nxt = pun->next;
    ptr = rate_pop();
    ptr->cont_tang = pun->cont_tang;
    ptr->mean_t = pun->mean_t;
    ptr->next = NULL;
    append(&path_head_ptr,ptr);
    /*push_rate(pun);*/
    pun = nxt;
   }/* Per ogni elemento */
  append(head,add_head);
 }/* End fusion */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void dispose_all_instances(res_ptr)
 Result_p res_ptr;
 {/* Init dispose_all_instances */
  Event_p ev_p,nev_p;

  if(res_ptr != NULL)
   {/* Puntatore consistente */
    ev_p = res_ptr->list;
    while (ev_p != NULL)
     {
      nev_p = ev_p->next;
      dispose_old_event(ev_p);
      ev_p = nev_p;
     }
   }/* Puntatore consistente */
 }/* End dispose_all_instances */
/* ********************************************************************* */
/*                                                                       */
/*    Funzioni che permettono il calcolo dei tassi associati alle        */
/*    transizioni abilitate                                              */
/*                                                                       */
/* ********************************************************************* */
static float normalizzazione(pun,pri)
Result_p pun;
int pri;
{
 double prod;
 double den = 0;
 Event_p ev_p = NULL;
 int tr;

 while (pun != NULL)
  {/* Per ogni transizione */
   ev_p = pun->list;
   prod = 0;
   tr = GET_TRANSITION_INDEX(ev_p);
   if(tabt[tr].pri == pri)
    {/* Se sono allo stesso livello di priorita' */
     while(ev_p != NULL)
      {/* Per ogni istanza */
       tr = GET_TRANSITION_INDEX(ev_p);
       prod += tabt[tr].mean_t * GET_ENABLING_DEGREE(ev_p);
       ev_p = NEXT_EVENT(ev_p);
      }/* Per ogni istanza */
     den += prod;
    }/* Se sono allo stesso livello di priorita' */
   pun = pun->next;
  }/* Per ogni transizione	*/
 return(den);
}
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void garbage_collect(fire_ptr)
 Tree_p fire_ptr;
 {/* Init garbage_collect */
  Result_p current_transition,next_transition;

  current_transition = fire_ptr->enabled_head;
  while (current_transition != NULL)
   {
    next_transition = current_transition->next;
    dispose_all_instances(current_transition);
    current_transition->list = NULL;
    push_result(current_transition);
    current_transition = next_transition;
   }
  fire_ptr->enabled_head = NULL;
 }/* End garbage_collect */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void DFS_evanescenti(length)
 int length;
 {/* Init DFS_evanescenti */
  int tr;
  int marking_pri;

  Result_p current_transition;

  Event_p ev_p,nev_p,copy_of_ev_p;

  Tree_p new_reached_marking;
  Tree_p dfs_fire_ptr;

  MRate_p pun = NULL;
  MRate_p marc_ragg = NULL;
  MRate_p head_marc = NULL;

  float denom,numer,mean_t;

  dfs_fire_ptr = new_reached_marking = reached_marking;
  marking_pri = dfs_fire_ptr->marking->pri;

  if(IS_VANISHING(marking_pri))
   denom = normalizzazione(dfs_fire_ptr->enabled_head,marking_pri);
  current_transition = dfs_fire_ptr->enabled_head;
  while (current_transition != NULL)
   {/* per tutte le transizioni abilitate */
    tr = GET_TRANSITION_INDEX(current_transition->list);
    if(tabt[tr].pri == marking_pri)
     {/* Solo per la stessa priorita' */
      copy_of_ev_p = get_new_event(tr);
      ev_p = current_transition->list;
      while(ev_p != NULL)
       {/* per ogni istanza */
	nev_p = ev_p->next;
	if(output_flag)
	 {/* Scrittura abilitata */
	  update_rg_files(TANGIBLE_OR_VANISHING,dfs_fire_ptr,tr,marking_pri);
	 }/* Scrittura abilitata */
	numer = GET_ENABLING_DEGREE(ev_p) * tabt[tr].mean_t;
	if(IS_VANISHING(marking_pri))
	 mean_t = numer/denom;
	else
	 mean_t = numer;
	copy_event(copy_of_ev_p,ev_p);
	fire_trans(ev_p);
	if(output_flag)
	 {/* Scrittura abilitata */
	  out_single_instance(ev_p,srg);
	  fprintf(srg,"--->   (rate %f)\n",mean_t);
	 }/* Scrittura abilitata */
#ifdef SYMBOLIC
        get_canonical_marking();
#endif
	length = marking_to_string();
	tro = 0;
	insert_tree(&root,&h,length); /* Piu' info nel symbolic */
	if (current_marking == initial_marking && !home)
	 home = 1;
	switch(tro)
	 {/* Vari tipi di marcatura raggiunta */
	  case DEAD_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,-1);
		}/* Scrittura abilitata */
	       break;
	  case VANISHING_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,1);
		}/* Scrittura abilitata */
	       pun = reached_marking->marking->path_head;
               while (pun != NULL)
                {
                 marc_ragg = rate_pop();
		 marc_ragg->cont_tang = pun->cont_tang;
		 marc_ragg->mean_t = pun->mean_t * mean_t;
                 marc_ragg->next = NULL;
                 append(&head_marc,marc_ragg);
                 pun = pun->next;
                }
	       break;
	  case TANGIBLE_OLD:
	       if(output_flag)
		{/* Scrittura abilitata */
		 update_rg_files(NORMAL,NULL,UNKNOWN,0);
		}/* Scrittura abilitata */
	       marc_ragg = rate_pop();
	       marc_ragg->cont_tang = cont_tang;
               marc_ragg->mean_t = mean_t;
               marc_ragg->next = NULL;
               append(&head_marc,marc_ragg);
	       break;
	  case VANISHING_LOOP:
	       fprintf(stdout,"ERRORE : CICLO DI EVANESCENTI \n");
	       exit(1);
	       break;
	  case NEW_MARKING:
	       enabled_head = NULL;
#ifdef SYMBOLIC
               string_to_marking(reached_marking->marking->marking_as_string);
#endif
	       update_en_list(ev_p,dfs_fire_ptr->enabled_head);
	       if(enabled_head == NULL)
		{/* Dead marking */
		 reached_marking->marking->cont_tang = ++dead;
		 reached_marking->marking->pri = -1;
#ifdef SYMBOLIC
		 ord_dead += mark_ordinarie;
#endif
		 if(output_flag)
		  update_rg_files(DEAD,NULL,UNKNOWN,UNKNOWN);
		}/* Dead marking */
               else
		{/* Live marking */
		 reached_marking->marking->pri = cur_priority;
	         if(!cur_priority)
		  {/* Marcatura tangibile */
		   tang++;
#ifdef SYMBOLIC
		   ord_tang += mark_ordinarie;
#endif
		   inqueue_stack(&top,&bottom,reached_marking);
		   reached_marking->enabled_head = enabled_head;
		   reached_marking->marking->cont_tang = tang;
		   if(output_flag)
		    {/* Scrittura abilitata */
		     update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		    }/* Scrittura abilitata */
		   marc_ragg = rate_pop();
		   marc_ragg->cont_tang = tang;
                   marc_ragg->mean_t = mean_t;
                   marc_ragg->next = NULL;
                   append(&head_marc,marc_ragg);
		  }/* Marcatura tangibile */
	         else
		  {/* Marcatura evanescente */
		   evan++;
#ifdef SYMBOLIC
		   ord_evan += mark_ordinarie;
#endif
		   reached_marking->enabled_head = enabled_head;
		   reached_marking->marking->cont_tang = evan;
		   if(output_flag)
		    {/* Scrittura abilitata */
		     update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		    }/* Scrittura abilitata */
		   DFS_evanescenti(length);
		   pun = path_head_ptr;
                   while (pun != NULL)
                    {
                     pun->mean_t *= mean_t;
                     pun = pun->next;
                    } 
		   append(&head_marc,path_head_ptr);
		   path_head_ptr = NULL;
		  }/* Marcatura evanescente */
		}/* Live marking */
	       break;
	 }/* Vari tipi di marcatura raggiunta */
	string_to_marking(dfs_fire_ptr->marking->marking_as_string);
        ev_p = nev_p;
       }/* per ogni istanza */
      dispose_old_event(copy_of_ev_p);
     }/* Solo per la stessa priorita' */
    current_transition = current_transition->next;
   }/* Per tutte le transizioni abilitate */
  if(new_reached_marking != NULL)
   fusion(&(new_reached_marking->marking->path_head),head_marc);
  garbage_collect(dfs_fire_ptr);
 }/* End DFS_evanescenti */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void build_graph()
 {/* Init build_graph */
  int j;
  int tr;
  int length;

  int marking_pri;

  Result_p current_transition;
  Result_p next_transition;

  Event_p ev_p,nev_p,copy_of_ev_p;

  Tree_p new_reached_marking;

  MRate_p cur;
  MRate_p nxt;

  float denom,numer,mean_t;

  tro = 0;
  time(&old_time);
#ifdef SYMBOLIC
  create_canonical_data_structure();
  get_canonical_marking();
#endif
  length = marking_to_string();

  tro = 0; 
  insert_tree(&root,&h,length);
  inqueue_stack(&top,&bottom,root);
  initial_marking = root;

  string_to_marking(root->marking->marking_as_string);

  if(output_flag)
   {/* Scrittura abilitata */
    fprintf(srg,"INITIAL MARKING\n");
    write_on_srg(srg,0);
    fprintf(srg,"\n");
   }/* Scrittura abilitata */

  initialize_en_list();  /* Inizializzazione eventi abilitati in M0 */

  if(enabled_head != NULL)
   {/* Marcatura Live */
    root->marking->pri = cur_priority;
    if(IS_TANGIBLE(cur_priority))
     {
      root->marking->cont_tang = ++tang;
#ifdef SYMBOLIC
      ord_tang += mark_ordinarie;
#endif
     }
    else
     {
      root->marking->cont_tang = ++evan;
#ifdef SYMBOLIC
      ord_evan += mark_ordinarie;
#endif
     }
   }/* Marcatura Live */
  else
   {/* Marcatura Dead */
    root->marking->pri = -1;
    root->marking->cont_tang = ++dead;
#ifdef SYMBOLIC
    ord_dead += mark_ordinarie;
#endif
   }/* Marcatura Dead */

  root->enabled_head = enabled_head;

  for(j=0; j<npl; j++)
   {
    min_place[j] = 255;
    max_place[j] = 0;
   }
  for (j=0; j<ntr; j++)
   if (max_priority < tabt[j].pri)
    max_priority = tabt[j].pri;
  code_marking();
  arrcpy(init_place,code_place,npl);

  fprintf(wngr,"%d\n",cur_priority ? 0 : 1 );

  while (top != NULL)
   {/* per tutte le marcature memorizzate sullo stack */
    fire_ptr = top;
    marking_pri = fire_ptr->marking->pri;
    pop(&top);
    string_to_marking(fire_ptr->marking->marking_as_string);
    code_marking();
    write_ctrs(ctrs);
    if(IS_VANISHING(marking_pri))
     {/* Marcatura evanascente : fattore di normalizzazione */
      denom = normalizzazione(fire_ptr->enabled_head,marking_pri);
     }/* Marcatura evanascente : fattore di normalizzazione */
    current_transition = fire_ptr->enabled_head;
    while(current_transition != NULL)
     {/* Per tutte le transizioni abilitate */
      next_transition = current_transition->next;
      tr = GET_TRANSITION_INDEX(current_transition->list);
      if(tabt[tr].pri == marking_pri)
       {/* Solo per transizioni alla stessa priorita' */
	copy_of_ev_p = get_new_event(tr);
	ev_p = current_transition->list;
	while(ev_p != NULL)
	 {/* Per ogni istanza abilitata */
	  nev_p = ev_p->next;
	  if(output_flag)
	   {/* Scrittura abilitata */
	    update_rg_files(TANGIBLE_OR_VANISHING,fire_ptr,tr,marking_pri);
	   }/* Scrittura abilitata */
	  numer = GET_ENABLING_DEGREE(ev_p) * tabt[tr].mean_t;
	  if(IS_VANISHING(marking_pri))
	   mean_t = numer/denom;
          else 
	   mean_t = numer;
	  copy_event(copy_of_ev_p,ev_p);
	  fire_trans(ev_p);
	  if(output_flag)
	   {/* Scrittura abilitata */
	    out_single_instance(ev_p,srg);
	    fprintf(srg,"--->   (rate %f)\n",mean_t);
	   }/* Scrittura abilitata */
#ifdef SYMBOLIC
          get_canonical_marking();
#endif
	  length = marking_to_string();
          tro = 0;
	  insert_tree(&root,&h,length); /* Piu' info nel symbolic */
	  if (current_marking == initial_marking && !home)
	   home = 1;
	  switch(tro)
	   {/* Vari tipi di marcatura raggiunta */
	    case DEAD_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,-1);
		  }/* Scrittura abilitata */
		 break;
	    case VANISHING_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,1);
		  }/* Scrittura abilitata */
		 cur = reached_marking->marking->path_head;
		 for(;cur!=NULL;cur=NEXT_PATH(cur))
                  fprintf(wngr,"%d %d %f\n"
			      ,fire_ptr->marking->cont_tang
			      ,cur->cont_tang
			      ,cur->mean_t*mean_t
			 );
		 break;
	    case TANGIBLE_OLD :
		 if(output_flag)
		  {/* Scrittura abilitata */
		   update_rg_files(NORMAL,NULL,UNKNOWN,0);
		  }/* Scrittura abilitata */
		 fprintf(wngr,"%d %d %f\n"
			     ,fire_ptr->marking->cont_tang
			     ,cont_tang
			     ,mean_t
			);
		 break;
	    case NEW_MARKING :
		 enabled_head = NULL;
#ifdef SYMBOLIC
		 string_to_marking(reached_marking->marking->marking_as_string);
#endif
		 update_en_list(ev_p,fire_ptr->enabled_head);
		 if(enabled_head == NULL)
		  {/* Dead marking */
		   reached_marking->marking->cont_tang = ++dead;
		   reached_marking->marking->pri = -1;
#ifdef SYMBOLIC
		   ord_dead += mark_ordinarie;
#endif
		   if(output_flag)
		    update_rg_files(DEAD,NULL,UNKNOWN,UNKNOWN);
		  }/* Dead marking */
                 else
		  {/* Live Marking */
                   reached_marking->marking->pri = cur_priority;
		   if(!cur_priority)
		    {/* marcatura tangibile */
		     tang++;
#ifdef SYMBOLIC
                     ord_tang += mark_ordinarie;
#endif
		     inqueue_stack(&top,&bottom,reached_marking);
		     reached_marking->enabled_head = enabled_head;
		     reached_marking->marking->cont_tang = tang;
		     if(output_flag)
		      {/* Scrittura abilitata */
		       update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		      }/* Scrittura abilitata */
		     fprintf(wngr,"%d %d %f\n"
				 ,fire_ptr->marking->cont_tang
				 ,tang
				 ,mean_t
			    );
		    }/* marcatura tangibile */
		   else
		    {/* Marcatura evanescente */
		     evan++;
#ifdef SYMBOLIC
                     ord_evan += mark_ordinarie;
#endif
		     path_head_ptr = NULL;
		     new_reached_marking = reached_marking;
		     reached_marking->enabled_head = enabled_head;
		     reached_marking->marking->cont_tang = evan;
		     if(output_flag)
		      {/* Scrittura abilitata */
		       update_rg_files(NORMAL,NULL,UNKNOWN,cur_priority);
		      }/* Scrittura abilitata */
		     DFS_evanescenti(length);
                     cur = new_reached_marking->marking->path_head;
		     for(;cur!=NULL;cur=NEXT_PATH(cur))
                      fprintf(wngr,"%d %d %f\n"
				  ,fire_ptr->marking->cont_tang
				  ,cur->cont_tang
				  ,cur->mean_t*mean_t
			     );
                     
		     for(cur = path_head_ptr;cur!=NULL;cur=nxt)
		      {
		       nxt = cur->next;
		       push_rate(cur);
		      }
                     
		    }/* Marcatura evanescente */
		  }/* Live Marking */
		 break;
	   }/* Vari tipi di marcatura raggiunta */
	  string_to_marking(fire_ptr->marking->marking_as_string);
	  ev_p = nev_p;
	 }/* Per ogni istanza abilitata */
        dispose_old_event(copy_of_ev_p);
       }/* Solo per transizioni alla stessa priorita' */
      current_transition = next_transition;
     }/* Per tutte le transizioni abilitate */
    garbage_collect(fire_ptr);
   }/* per tutte le marcature memorizzate sullo stack */
  time(&new_time);
  write_grg(grg);
  fprintf(wngr,"%d\n",tang+1);
  fprintf(rgr_aux,"toptan= %d\n",tang);
  fprintf(rgr_aux,"topvan= %d\n",evan);
  if(output_flag)
   {/* Scrittura abilitata */
    write_final_results(srg);
   }/* Scrittura abilitata */
  write_final_results(stdout);
 if(dead > 0)
  {
   fprintf(stdout,"Reachability graph contains dead markings !!\n");
   exit(1);
  }
 }/* End build_graph */
#endif
