%{
# include <ctype.h>
# include <string.h>
# include "../INCLUDE/const.h"
# include "../INCLUDE/struct.h"
# include "../INCLUDE/var_ext.h"
# include "../INCLUDE/macros.h"

extern int parser();
extern struct MD_RATE *get_md_rate();
extern void fill_transition_data_structure();
extern char *ecalloc();
extern char *emalloc();

extern FILE *jjin,*mfp;
extern int read_domain[];  /* In wn.yac */

int has_repetitions();

void ungets();
void get_next();
void parse_node();
void init_nodes();
void init_marking_parameters();
void init_places();
void init_rate_parameters();
void init_groups();
void init_transitions();

int ck=-1,skip=0,nil=0,nol=0,nhl=0;
int place_ind,ts,tt,til,mark_value,i,place_mark,gp,pl;

float rate_value,pos,pos2,tr;

char cc;

%}
%s NETmark place rate group NETtrans inlink outlink iniblink skipin skipout skipinb
letter [a-zA-Z_]
digit [0-9]
name {letter}({letter}|{digit})*
%%
<iniblink>[0-9]+	   {/* ARCHI INIBITORI */

parse_node(INHIBITOR,nhl);
nhl++;
if(ntr==el[4]-1 && nhl==tabt[ntr].inib_arc)
 {/* Fine lettura degli inibitori */
  fill_transition_data_structure(ntr);
  ntr++;
  nhl=0;
  strcpy(temp2,kktext);
 }/* Fine lettura degli inibitori */
BEGIN skipinb;

                   }/* ARCHI INIBITORI */
<skipinb>{name}    {/* SKIP ARCHI INIBITORI SPEZZATI */

fill_transition_data_structure(ntr);
nhl=0;
ntr++;
strcpy(temp2,kktext);
ungets(kkin);
BEGIN NETtrans;

		   }/* SKIP ARCHI INIBITORI SPEZZATI */
<skipinb>[0-9]+\.[0-9]+ {/*Nessuna azione*/}
<skipinb>[0-9]+	   {/* SKIP ARCHI INIBITORI SPEZZATI */

strcpy(temp2,kktext);
ungets(kkin);
BEGIN iniblink;

		   }/* SKIP ARCHI INIBITORI SPEZZATI */
<outlink>[0-9]+	   {/* ARCHI DI USCITA */

parse_node(OUTPUT,nol);
nol++;
BEGIN skipout;

	           }/* ARCHI DI USCITA */
<skipout>[0-9]+\.[0-9]+ {/*Nessuna azione*/}
<skipout>[0-9]+	   {/* SKIP DI ARCHI DI USCITA */

if(nol==tabt[ntr].out_arc)
 {/* Fine lettura degli archi di uscita */
  tabt[ntr].inib_arc=atoi(kktext);
  init_nodes(INHIBITOR,tabt[ntr].inib_arc);
  nol=0;
  if(tabt[ntr].inib_arc==0)
   {/* Nessun arco inibitore */
    fill_transition_data_structure(ntr);
    ntr++;
    nhl=0;
    BEGIN NETtrans;
   }/* Nessun arco inibitore */
  else 
   BEGIN iniblink;
 }/* Fine lettura degli archi di uscita */
else
 {/* Altri archi di uscita */
  strcpy(temp2,kktext);
  ungets(kkin);
  BEGIN outlink;
 }/* Altri archi di uscita */

                   }/* SKIP DI ARCHI DI USCITA */
<inlink>[0-9]+	   {/* ARCHI DI INGRESSO */

parse_node(INPUT,nil);
nil++;
BEGIN skipin;

		   }/* ARCHI DI INGRESSO */
<skipin>[0-9]+\.[0-9]+	{/*Nessuna azione*/}
<skipin>[0-9]+	   {/* SKIP DI ARCHI DI INGRESSO */

if(nil==tabt[ntr].in_arc)
 {/* Fine degli archi di ingresso */
  tabt[ntr].out_arc=atoi(kktext);
  init_nodes(OUTPUT,tabt[ntr].out_arc);
  nil=0;
  input_flag=FALSE;
  if(tabt[ntr].out_arc!=0)
   BEGIN outlink;
  else
   BEGIN skipout;
 }/* Fine degli archi di ingresso */
else
 {/* Altri archi di ingresso */
  strcpy(temp2,kktext);
  ungets(kkin);
  BEGIN inlink;
 }/* Altri archi di ingresso */

	           }/* SKIP DI ARCHI DI INGRESSO */
<NETtrans>{name}	   {/* LETTURA DELLE TRANSIZIONI */

if(ntr==el[ck])
 return;
tabt[ntr].trans_name = (char *)ecalloc(strlen(kktext)+1,sizeof(char));
strcpy(tabt[ntr].trans_name,kktext);
fscanf(kkin,"%f %d %d %d",&tr,&ts,&tt,&til);
if(tr==-510)
 tabt[ntr].md_rate_val=get_md_rate(ntr);
else
 if(tr<0)
  tabt[ntr].mean_t=tabrp[-(int)tr-1].rate_val;
 else
  tabt[ntr].mean_t=(double)tr;
tabt[ntr].pri=tt;
tabt[ntr].timing=tt;
if(tabt[ntr].timing > DISTR_CODE ) 
 {/* Transizione non esponenziale (Servira' ?) */
  tabt[ntr].pri=0;
 }/* Transizione non esponenziale (Servira' ?) */
tabt[ntr].no_serv=ts;
if(ts == INFINITE_SERVER)
 tabt[ntr].no_serv = 0;
tabt[ntr].in_arc=til;

init_nodes(INPUT,til);

comp_check=0;
for(cc=getc(kkin);cc!='\n'&& cc!='@' && cc!='[';cc=getc(kkin));
switch(cc)
 {/* Tipo di dominio della transizione */
  case '@'  : {
	       /************************************/
	       /*  Da implementare adattando la	   */
	       /*  grammatica affinche'riconosca   */
	       /*  come color anche descrizioni    */
	       /*  di domini riempiendo una tabella*/
	       /************************************/
	       break;
	      }
  case '\n' : {/* Dominio neutro*/
	       break;
	      }/* Dominio neutro*/
  default   : {/*Dominio colorato da parsificare*/
	       ungetc(cc,kkin);
	       ungetc(' ',kkin);
	       ungetc('k',kkin);
	       ungetc('~',kkin);
	       jjin=kkin;
	       parser();
               kkin=jjin;
	      }/*Dominio colorato da parsificare*/
 }/* Tipo di dominio della transizione */
if(tabt[ntr].in_arc!=0)
 {/* Ci sono archi di ingresso */
  input_flag=TRUE;
  BEGIN inlink;
 }/* Ci sono archi di ingresso */
else
 {/* Non ci sono archi di ingresso */
  input_flag=FALSE;
  BEGIN skipin;
 }/* Non ci sono archi di ingresso */
/* BEGIN inlink; */

                    }/* LETTURA DELLE TRANSIZIONI */
<group>{name}	    {/* LETTURA DEI GRUPPI */

tabg[ngr].name = (char *)ecalloc(strlen(kktext)+1,sizeof(char));
strcpy(tabg[ngr].name,kktext);
fscanf(kkin,"%f %f %d",&pos,&pos2,&gp);
tabg[ngr].priority=gp;
while((cc=getc(kkin))!='\n');
if(++ngr==el[ck]) 
 get_next(); 

                    }/* LETTURA DEI GRUPPI */
<rate>{name}	    {/* LETTURA DEI RATES */

tabrp[nrp].rate_name = (char *)ecalloc(strlen(kktext)+1,sizeof(char));
strcpy(tabrp[nrp].rate_name,kktext);
fscanf(kkin,"%f",&rate_value);
tabrp[nrp].rate_val=rate_value;
while((cc=getc(kkin))!='\n');
if(++nrp==el[ck]) 
 get_next(); 

		    }/* LETTURA DEI RATES */
<place>{name}	    {/* LETTURA DEI POSTI */

tabp[npl].place_name = (char *)ecalloc(strlen(kktext)+1,sizeof(char));
strcpy(tabp[npl].place_name,kktext);
fscanf(kkin,"%d",&place_mark);
for(cc=getc(kkin);cc!='\n'&& cc!='@' && !isalpha(cc);cc=getc(kkin));
switch(cc)
 {/* Tipo di dominio del posto */
  case '@'  : {
	       /************************************/
	       /*  Da implementare adattando la	   */
	       /*  grammatica affinche'riconosca   */
	       /*  come color anche descrizioni    */
	       /*  di domini riempiendo una tabella*/
	       /************************************/
	       break;
	      }
  case '\n' : {/* Dominio neutro*/
	       tabp[npl].comp_num=0;
	       break;
	      }/* Dominio neutro*/
  default   : {/*Dominio colorato da parsificare*/
	       ungetc(cc,kkin);
	       ungetc(' ',kkin);
	       ungetc('w',kkin);
	       ungetc('~',kkin);
	       jjin=kkin;
	       parser();
	       kkin=jjin;
	       tabp[npl].dominio = (int *)ecalloc(tabp[npl].comp_num,sizeof(int));
	       for(i = 0; i < tabp[npl].comp_num ; i++)
		tabp[npl].dominio[i] = read_domain[i];
	      }/*Dominio colorato da parsificare*/
 }/* Tipo di dominio del posto */
tabp[npl].position=place_mark;
for(i=0,tabp[npl].card=1;i<tabp[npl].comp_num;i++)
 tabp[npl].card*=tabc[tabp[npl].dominio[i]].card;
if(++npl==el[ck]) 
  get_next();

                   }/* LETTURA DEI POSTI */
<NETmark>{name}       {/* LETTURA DEI MARKING PARAMETERS */

tabmp[nmp].mark_name = (char *)ecalloc(strlen(kktext)+1,sizeof(char));
strcpy(tabmp[nmp].mark_name,kktext);
fscanf(kkin,"%d",&mark_value);
tabmp[nmp].mark_val=mark_value;
while((cc=getc(kkin))!='\n');
if(++nmp==el[ck]) 
 get_next(); 

                   }/* LETTURA DEI MARKING PARAMETERS */
f[' ']             {/* INIZIO LETTURA FILE .NET */

fscanf(kkin,"%d %d %d %d %d %d",&el[0],&el[1],&el[2],&el[4],&el[3],&el[5]);
while((cc=getc(kkin))!='\n');
if(el[4]>MAX_TRANS)
 out_error(ERROR_LOW_MAX_TRANS,0,0,0,0,NULL,NULL);
get_next();

                   }/* INIZIO LETTURA FILE .NET */
%%
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void get_next()
{/* Init get_next */
 ck++;
 for(;el[ck]==0 && ck<MAX_OBJ;ck++);
 switch(ck)
  {/* Entita' da leggere */
   case 0 : {/* Parametri di marking */
	     tabmp=(struct MARK_PAR *)ecalloc(el[0],sizeof(struct MARK_PAR));
	     init_marking_parameters(el[0]);
	     BEGIN NETmark;
	     break;
	    }/* Parametri di marking */
   case 1 : {/* Posti */
	     tabp=(struct PLACES *)ecalloc(el[1],sizeof(struct PLACES));
	     init_places(el[1]);
	     BEGIN place;
	     break;
	    }/* Posti */
   case 2 : {/* Parametri di rates */
	     tabrp=(struct RATE_PAR *)ecalloc(el[2],sizeof(struct RATE_PAR));
	     init_rate_parameters(el[2]);
	     BEGIN rate;
	     break;
	    }/* Parametri di rates */
   case 3 : {/* Gruppi di priorita' */
	     tabg=(struct GROUP *)ecalloc(el[3],sizeof(struct GROUP));
	     init_groups(el[3]);
	     BEGIN group;
	     break;
	    }/* Gruppi di priorita' */
   case 4 : {/* Transizioni */
	     tabt=(Trans_p)ecalloc(el[4],sizeof(struct TRANS));
	     init_transitions(el[4]);
	     BEGIN NETtrans;
	     break;
	    }/* Transizioni */
   default : {
	     break;
	     }
  }/* Entita' da leggere */
}/* End get_next */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void parse_node(type,pos)
 int type;
 int pos;
 {/* Init parse_node */
  int comp,ii;

  Node_p node = NULL;
  Coeff_p func_ptr = NULL;

  switch(type)
   {/* Tipo di posti */
    case INPUT	   : node = tabt[ntr].inptr;
		     break;
    case OUTPUT    : node = tabt[ntr].outptr;
		     break;
    case INHIBITOR : node = tabt[ntr].inibptr;
		     break;
   }/* Tipo di posti */

  for(ii=0;ii<pos;node=NEXT_NODE(node),ii++);

  node->molt = atoi(kktext);  /* Init campo */
  node->analyzed = FALSE;     /* Init campo */

  fscanf(kkin,"%d",&place_ind);

  node->place_no = pl = place_ind - 1; /* Init campo */

  for(cc = getc(kkin); cc!='\n'&& cc!='@' && cc!='.';cc = getc(kkin));
  switch(cc)
   {/* Tipo di descrizione della funzione */
      case '@'  : {
	           /************************************/
  	           /*  Da implementare adattando la	   */
	           /*  grammatica affinche'riconosca   */
	           /*  come color anche descrizioni    */
	           /*  di funzioni riempiendo una ta   */
	           /*  bella			   */
	           /************************************/
  	           break;
  	          }
      case '\n' : {/* Nessuna funzione */
                   if(IS_NEUTRAL(pl))
                    {/* Posto con dominio neutro */
                     node->arcfun = NULL;	   /* Init campo */
                    }/* Posto con dominio neutro */
                   else
                    {/* Posto con dominio colorato */
		     comp = GET_PLACE_COMPONENTS(pl);
		     if(has_repetitions(pl))
		      {/* Transizione con dominio con ripetizioni */
		       out_error(ERROR_REPETITIONS_AND_NO_FUNCTION,pl,ntr,0,0,NULL,NULL);
		      }/* Transizione con dominio con ripetizioni */
		     for(i=0;i<comp;i++)
                      if(get_proj_num("?",tabp[pl].dominio[i])!=1)
		       {/* Transizione con dominio con ripetizioni */
			out_error(ERROR_AMBIGUOUS_DEFINITION,pl,ntr,0,0,NULL,NULL);
		       }/* Transizione con dominio con ripetizioni */
		     func_ptr = (Coeff_p)emalloc(sizeof(struct ENN_COEFF));
		     func_ptr->enn_coef = 1;
		     func_ptr->card = 1;
		     func_ptr->guard = NULL;
		     func_ptr->next = NULL;
		     func_ptr->coef = (struct COEFF *)ecalloc(comp,sizeof(struct COEFF));
		     for(i=0;i<comp;i++)
                      {/* Settaggio dei parametri dell'identita' */
		       func_ptr->coef[i].xsucc_coef=(int *)ecalloc(3,sizeof(int));
		       func_ptr->coef[i].xsucc_coef[0]=1;
		       func_ptr->coef[i].xsucc_coef[1]=0;
		       func_ptr->coef[i].xsucc_coef[2]=0;
		       func_ptr->coef[i].sbc_coef=(int *)ecalloc(tabc[tabp[pl].dominio[i]].sbc_num,sizeof(int));
		       for(ii=0;ii<tabc[tabp[pl].dominio[i]].sbc_num ; ii++)
		        func_ptr->coef[i].sbc_coef[ii] = 0;
                      }/* Settaggio dei parametri dell'identita' */
		     node->arcfun = func_ptr; /* Init campo */
                    }/* Posto con dominio colorato */
	           break;
	          }/* Nessuna funzione */
       default  : {/* Arco con funzione */
		   if(IS_NEUTRAL(pl))
		    {/* Posto neutro */
		     out_error(ERROR_NEUTRAL_PLACE_AND_FUNCTION,pl,ntr,0,0,NULL,NULL);
		    }/* Posto neutro */
                   else
		    {/* Posto colorato */
	             while(getc(kkin)!='.');
	             for(i=1;i<=6;i++)
		      getc(kkin);
	             ungetc('f',kkin);
	             ungetc('~',kkin);
	             fun_ptr = NULL;
	             pl_ind = node->place_no;  /* Init campo */
	             jjin=kkin;
	             parser();
	             kkin=jjin;
	             node->arcfun = fun_ptr;	 /* Init campo */
		    }/* Posto colorato */
		   break;
	          }/* Arco con funzione */
  }/* Tipo di descrizione della funzione */
}/* End parse_node */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int has_repetitions(p)
 int p;
 {/* Init has repetitions */
  int i,j;

  for(i=0;i<tabp[p].comp_num;i++)
   for(j=0;j<tabp[p].comp_num;j++)
    if(j != i)
     if(tabp[p].dominio[i]==tabp[p].dominio[j])
      return(TRUE);
  return(FALSE);
 }/* End has repetitions */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_nodes(type,num)
 int type;
 int num;
 {/* Init init_nodes */
  int ii;
  Node_p place_list = NULL;
  Node_p node_ptr = NULL;

  if(num > 0)
   {/* Almeno un nodo */
    for(ii = 0; ii < num ; ii++)
     {/* Inizializzazione */
      node_ptr = (Node_p)emalloc(sizeof(struct NODO));
      node_ptr->arcfun = NULL;
      node_ptr->molt = UNKNOWN;
      node_ptr->fun_card = UNKNOWN;
      node_ptr->place_no = UNKNOWN;
      node_ptr->skip = UNKNOWN;
      node_ptr->analyzed = UNKNOWN;
      node_ptr->type = UNKNOWN;
      node_ptr->involved_in_CC_SC = FALSE;
      node_ptr->test_arc = FALSE;
      node_ptr->next = place_list;
      place_list = node_ptr;
     }/* Inizializzazione */
   }/* Almeno un nodo */
  else
   place_list = NULL;
  switch(type)
   {/* Tipo di posti */
    case INPUT	: tabt[ntr].inptr = place_list;
		  break;
    case OUTPUT : tabt[ntr].outptr = place_list;
		  break;
    case INHIBITOR : tabt[ntr].inibptr = place_list;
		  break;
   }/* Tipo di posti */
 }/* End init_nodes */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_marking_parameters(num)
 int num;
 {/* Init init_marking_parameters */
  int i;

  for(i = 0; i < num; i++)
   {/* Per ogni elemento della tabella */
    tabmp[i].mark_name = NULL;
    tabmp[i].mark_val = UNKNOWN;
   }/* Per ogni elemento della tabella */
 }/* End init_marking_parameters */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_places(num)
 int num;
 {/* Init init_places */
  int i;

  for(i = 0; i < num; i++)
   {/* Per ogni elemento della tabella */
    tabp[i].place_name = NULL;
    tabp[i].dominio = NULL;
    tabp[i].comp_num = UNKNOWN;
    tabp[i].card = UNKNOWN;
    tabp[i].position= UNKNOWN;
#ifdef SIMULATION
#ifdef GREATSPN
    tabp[i].tagged = TRUE;
#else
    tabp[i].tagged = FALSE;
#endif
#endif
   }/* Per ogni elemento della tabella */
 }/* End init_places */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_rate_parameters(num)
 int num;
 {/* Init init_rate_parameters */
  int i;

  for(i = 0; i < num; i++)
   {/* Per ogni elemento della tabella */
    tabrp[i].rate_name = NULL;
    tabrp[i].rate_val = UNKNOWN;
   }/* Per ogni elemento della tabella */
 }/* End init_rate_parameters */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_groups(num)
 int num;
 {/* Init init_groups */
  int i;

  for(i = 0; i < num; i++)
   {/* Per ogni elemento della tabella */
    tabg[i].name = NULL;
    tabg[i].priority = UNKNOWN;
   }/* Per ogni elemento della tabella */
 }/* End init_groups */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void init_transitions(num)
 int num;
 {/* Init init_transitions */
  int i,j;

  for(i = 0; i < num; i++)
   {/* Per ogni elemento della tabella */
    tabt[i].trans_name = NULL;
    tabt[i].names = NULL;

    tabt[i].in_arc = UNKNOWN;
    tabt[i].out_arc = UNKNOWN ;
    tabt[i].inib_arc = UNKNOWN ;

#ifdef SIMULATION
    tabt[i].skippable = UNKNOWN;
#ifdef GREATSPN
    tabt[i].tagged = TRUE;
#else
    tabt[i].tagged = FALSE;
    tabt[i].en_deg = UNKNOWN;
#endif
#endif
    tabt[i].no_serv = UNKNOWN;
    tabt[i].pri = UNKNOWN ;
    tabt[i].timing = UNKNOWN;
    tabt[i].comp_num = UNKNOWN;

    tabt[i].dominio = NULL;
    tabt[i].comp_type = NULL;
    tabt[i].rip = NULL;
    tabt[i].off = NULL;
#ifdef SYMBOLIC
#ifdef SIMULATION
    tabt[i].split_type = NULL;
    tabt[i].pre_split = UNKNOWN;
#endif
#endif
    tabt[i].add_l = NULL;
    tabt[i].test_l = NULL;
    tabt[i].me_l = NULL;

    tabt[i].inptr = NULL;
    tabt[i].outptr = NULL ;
    tabt[i].inibptr = NULL ;

    tabt[i].guard = NULL ;
    tabt[i].mean_t = UNKNOWN;

    tabt[i].md_rate_val = NULL;

#ifdef SIMULATION
    tabt[i].instances_h = NULL;
    tabt[i].instances_t = NULL;

    tabt[i].residual = NULL;
    tabt[i].enabl_next = NULL;
#endif

   }/* Per ogni elemento della tabella */
 }/* End init_transitions */
/*****************************************************************
nome	       :
descrizione    :
parametri      :

valori ritorno :
******************************************************************/
void ungets(stream)
 FILE *stream;
 {/* Init ungets */
  int i ;

  for( i = strlen(temp2) - 1 ; i >= 0 ; i--)
   ungetc(temp2[i],stream);
 }/* End ungets */
